{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,W+,X+,Y+}
{$M 8192,8192}
(*========================================================*)
(*                       FBDEMO.PAS                       *)
(*         (C) 1993 Andreas Siegmund & DMV-Verlag         *)
(*        Demonstration fr Fillbars in Dialogboxen       *)
(*  Compiler: Turbo Pascal f. Windows, Borland Pascal 7.0 *) 
(*========================================================*)

PROGRAM FBDemo;

{$R FBDEMO.RES}

USES
  WinProcs, WinTypes,
  {$IFDEF VER70} ODialogs, OWindows, {$ELSE} WObjects,
  {$ENDIF} FillBar, BWCC;

CONST
  id_MinusButton = 100;
  id_PlusButton  = 110;

TYPE
  TestApp = OBJECT(tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

  pMainWin = ^tMainWin;
  tMainWin = OBJECT(tWindow)
    CONSTRUCTOR Init(aParent: pWindowsObject; aName: pChar);
    PROCEDURE   Dialog(VAR Msg: tMessage);
                  VIRTUAL cm_First + 100;
    PROCEDURE   Quit(VAR Msg: tMessage);
                  VIRTUAL cm_First + 200;
  END;

  pTestDlg = ^tTestDlg;
  tTestDlg = OBJECT(tDialog)
    FillBarValue : INTEGER;
    CONSTRUCTOR Init(aParent: pWindowsObject; aName: pChar);
    PROCEDURE    PlusButton(VAR Msg: tMessage);
                   VIRTUAL id_First + id_PlusButton;
    PROCEDURE MinusButton(VAR Msg: tMessage);
                   VIRTUAL id_First + id_MinusButton;
  END;

(*========================================================*)

PROCEDURE TestApp.InitMainWindow;
BEGIN
  MainWindow := New(pMainWin, Init(NIL, 'FillBar-Demo'));
END;

CONSTRUCTOR tMainWin.Init;
BEGIN
  tWindow.Init(aParent, aName);
  Attr.Menu := LoadMenu(hInstance, pChar(100));
END;

PROCEDURE tMainWin.Dialog;
VAR
  Dlg: pTestDlg;
BEGIN
  BWCCMessageBox(hWindow,
                 'Jetzt kommt der Fillbar-Test-Dialog!',
                 'Meldung', mb_OK OR mb_IconExclamation);
  Dlg := New(pTestDlg, Init(@Self, pChar(100)));
  Application^.ExecDialog(Dlg);
END;

PROCEDURE tMainWin.Quit;
BEGIN
  CloseWindow;
END;

CONSTRUCTOR tTestDlg.Init;
BEGIN
  tDialog.Init(aParent, aName);
  FillBarValue := 0;
END;

PROCEDURE tTestDlg.PlusButton;
BEGIN
  IF FillBarValue < 100 THEN
  BEGIN
    Inc(FillBarValue, 5);
    SetFillBarValue(hWindow, 120, FillBarValue);
    MessageBeep(0);
  END;
END;

PROCEDURE tTestDlg.MinusButton;
BEGIN
  IF FillBarValue > 0 THEN
  BEGIN
    Dec(FillBarValue, 5);
    SetFillBarValue(hWindow, 120, FillBarValue);
    MessageBeep(0);
  END;
END;

VAR
  App : TestApp;

BEGIN
  App.Init('FillBar-Demo');
  App.Run;
  App.Done;
END.

(*========================================================*)
(*                   Ende von FBDEMO.PAS                  *)
