/* ------------------------------------------------------ */
/*                     ICOCON.C                           */
/* Windowsprogramm zum Konvertieren von Windows- in OS/2- */
/* Icons und umgekehrt. (Hauptprogramm)                   */
/*             Compiler: Microsoft-C 6.0                  */
/*          (C) 1993 Kay Glahn & DMV-Verlag               */
/* ------------------------------------------------------ */

#include <windows.h>
#include "icocon.h"

HWND             hDlg;

LPSTR            lpCommand;

HANDLE           hXORBmpMem[2],
                 hANDBmpMem[2],
                 hPalMem[2],
                 hResDirMem[2],
                 hInst;

HBITMAP FAR      *lphXORBitmap[2],
        FAR      *lphANDBitmap[2];

HPALETTE FAR     *lphPal[2];

ICONRESOURCE FAR *lpResDir[2];

char             FileName[2][128],
                 OldFileName[2][128],
                 DefSpec[2][13]={"*.ico","*.ico"},
                 str[255];

OFSTRUCT         OfStruct;

BOOL             change[2]={FALSE,FALSE},
                 Result,
                 Result1,
                 Result2,
                 Result3;

FARPROC          lpFarProc;

int              hFile,
                 Success,
                 i,
                 j,
                 Number,
                 CurrIcon,
                 CurrFile,
                 OtherFile,
                 PrevIcon,
                 PrevFile,
                 StrNumber,
                 OldStrNumber;

WORD             Quantity[2],
                 x,
                 y,
                 WinOS2[2]={1,1};

HDC              hDC;

LONG             lDlgBaseUnits;

PAINTSTRUCT      ps;

HBRUSH           hBrush,
                 hOldBrush;

HCURSOR          hWaitCursor,
                 hOldCursor;

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
  hInst=hInstance;

  if(!hPrevInst)
  {
    WNDCLASS wndclass;

    wndclass.style = CS_OWNDC;
    wndclass.lpfnWndProc = DefDlgProc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = DLGWINDOWEXTRA;
    wndclass.hInstance=hInst;
    wndclass.hIcon=LoadIcon(hInst,"Icon");
    wndclass.hCursor=LoadCursor(NULL, IDC_ARROW);
    wndclass.hbrBackground = NULL;
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = "mainbox";
    RegisterClass(&wndclass);
  }

  lpCommand=lpCmdLine;
  OemToAnsi(lpCmdLine, lpCommand);
  lpCommand=AnsiLower(lpCommand);

  return DialogBox(hInst, "icoconv", NULL, MakeProcInstance(WinDlg, hInst));
}

int FAR PASCAL WinDlg(HWND hDialog, WORD message, WORD wParam, DWORD lParam)
{
  HMENU hSysMenu;

  hDlg=hDialog;
  switch(message)
  {
    case WM_INITDIALOG:

      CurrFile=0;
      PrevFile=0;
      CurrIcon=0;
      PrevIcon=0;

      for(j=0;j<2;j++)
      {
        Quantity[j]=0;
        lstrcpy(FileName[j],"keinname.ico");
        hXORBmpMem[j] = GlobalAlloc(GMEM_MOVEABLE, 1);
        hANDBmpMem[j] = GlobalAlloc(GMEM_MOVEABLE, 1);
        hPalMem[j] = GlobalAlloc(GMEM_MOVEABLE, 1);
        hResDirMem[j] = GlobalAlloc(GMEM_MOVEABLE, 1);
      }

      hWaitCursor=LoadCursor(NULL, IDC_WAIT);

      CenterWnd(hDlg, NULL);

      hSysMenu=GetSystemMenu(hDlg,0);

      AppendMenu(hSysMenu, MF_SEPARATOR, 0, NULL);
      AppendMenu(hSysMenu, MF_STRING, IDC_ABOUT,
                 "&ber Icon Converter...");
      AppendMenu(hSysMenu, MF_STRING, IDC_HELP,
                 "&Hilfe...");

      if(lstrlen(lpCommand)>0)
      {
        lstrcpy(FileName[CurrFile], lpCommand);
        hFile=OpenFile(FileName[CurrFile], (LPOFSTRUCT) &OfStruct, OF_READ);

        if (hFile)
        {
          if(WinOS2[CurrFile]=CheckFileType(hFile))
              Result=RetrieveIconFile(&hXORBmpMem[CurrFile],
                                &hANDBmpMem[CurrFile],
                                &hPalMem[CurrFile],
                                &hResDirMem[CurrFile],
                                hFile,
                                hDlg,
                                &Quantity[CurrFile]);
          else
              Result=RetrieveIconFile2(&hXORBmpMem[CurrFile],
                                 &hANDBmpMem[CurrFile],
                                 &hPalMem[CurrFile],
                                 &hResDirMem[CurrFile],
                                 hFile,
                                 hDlg,
                                 &Quantity[CurrFile]);

          if (Result)
          {
            _lclose(hFile);
            CurrIcon=0;

            ShowFileName(FileName[CurrFile]);

            SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                 LB_RESETCONTENT, NULL, NULL);

            lpResDir[CurrFile] = (ICONRESOURCE FAR*)
                 GlobalLock(hResDirMem[CurrFile]);

            for(i=0;i<Quantity[CurrFile];i++)
            {
              wsprintf(str,"%ix%i %i Farben",
                (int)lpResDir[CurrFile][i].Width,
                (int)lpResDir[CurrFile][i].Height,
                (int)lpResDir[CurrFile][i].ColorCount);
              SendDlgItemMessage(hDlg,
                 (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                 LB_ADDSTRING, NULL, (LONG)(LPSTR)str);
            }

            GlobalUnlock(hResDirMem[CurrFile]);

            SendDlgItemMessage(hDlg,
               (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                  LB_SETCURSEL, CurrIcon, NULL);
            SendDlgItemMessage(hDlg,
               (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
                  LB_SETCURSEL, -1, NULL);

            GetPosition(&x, &y);
            InvalidateRect(hDlg,NULL,TRUE);
            UpdateWindow(hDlg);
            PrevFile=CurrFile;
          }
        }
      }
      return TRUE;
      break;
    case WM_COMMAND:
      Command(wParam,lParam);
      break;
    case WM_PAINT:
      if(Quantity[CurrFile]>0)
      {
        hDC=BeginPaint(hDlg,&ps);
        ShowIcon(hDC,x,y);
        EndPaint(hDlg,&ps);
      }
      break;
    case WM_SYSCOMMAND:
      if((wParam & 0xfff0)==SC_CLOSE)
      {
        if(QuerySaveFile(hDlg,
                         hXORBmpMem[0],
                         hANDBmpMem[0],
                         hPalMem[0],
                         hResDirMem[0],
                         Quantity[0],
                         FileName[0],
                         &change[0]))
        {
          if(QuerySaveFile(hDlg,
                           hXORBmpMem[1],
                           hANDBmpMem[1],
                           hPalMem[1],
                           hResDirMem[1],
                           Quantity[1],
                           FileName[1],
                           &change[1]))
          {
            for(j=0;j<2;j++)
            {
              lphXORBitmap[j] = (HBITMAP FAR*)
                     GlobalLock((HANDLE)hXORBmpMem[j]);
              lphANDBitmap[j] = (HBITMAP FAR*)
                     GlobalLock((HANDLE)hANDBmpMem[j]);
              lphPal[j] = (HPALETTE FAR*)
                     GlobalLock((HANDLE)hPalMem[j]);

              for(i=0;i<Quantity[j];i++)
              {
                DeleteObject(lphXORBitmap[j][i]);
                DeleteObject(lphANDBitmap[j][i]);
                DeleteObject(lphPal[j][i]);
              }

              GlobalUnlock((HANDLE)hXORBmpMem[j]);
              GlobalUnlock((HANDLE)hANDBmpMem[j]);
              GlobalUnlock((HANDLE)hPalMem[j]);

              GlobalFree(hXORBmpMem[j]);
              GlobalFree(hANDBmpMem[j]);
              GlobalFree(hPalMem[j]);
              GlobalFree(hResDirMem[j]);
            }

            EndDialog(hDlg,NULL);
            return TRUE;
          }
        }
      }
      switch(wParam)
      {
        case IDC_ABOUT:
          lpFarProc = MakeProcInstance(About, hInst);
          DialogBox(hInst, "AboutBox", hDlg, lpFarProc);
          FreeProcInstance(lpFarProc);
          break;
        case IDC_HELP:
          lpFarProc = MakeProcInstance(HelpDlg, hInst);
          DialogBox(hInst, "Help", hDlg, lpFarProc);
          FreeProcInstance(lpFarProc);
          break;
      }
      break;
    case WM_QUERYENDSESSION:
      if(QuerySaveFile(hDlg,hXORBmpMem[0],hANDBmpMem[0],hPalMem[0],hResDirMem[0],Quantity[0],FileName[0],&change[0])==TRUE)
      {
        if(QuerySaveFile(hDlg,hXORBmpMem[1],hANDBmpMem[1],hPalMem[1],hResDirMem[1],Quantity[1],FileName[1],&change[1])==TRUE)
          return FALSE;
      }
      return TRUE;
      break;
  }
  return FALSE;
}

BOOL FAR PASCAL About(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WORD wParam;
LONG lParam;
{
  switch (message)
  {
    case WM_INITDIALOG:
      CenterWnd(hDlg, NULL);
      return (TRUE);
    case WM_COMMAND:
      if (wParam == IDOK || wParam == IDCANCEL)
      {
        EndDialog(hDlg, TRUE);
        return (TRUE);
      }
      break;
  }
  return (FALSE);
}

void CenterWnd(HWND hChange, HWND hRelat)
{
  RECT rChange, rRelat;

  GetWindowRect(hChange,&rChange);

  if(!hRelat)
    hRelat = GetDesktopWindow();

  GetWindowRect(hRelat,&rRelat);

  SetWindowPos(hChange, NULL,
    rRelat.left+((rRelat.right-rRelat.left)-
    (rChange.right-rChange.left))/2,
    rRelat.top +((rRelat.bottom-rRelat.top)-
    (rChange.bottom-rChange.top))/2,
    0, 0, SWP_NOSIZE);
}

BOOL ShowIcon(HDC hDC, int XPos, int YPos)
{
  HDC     hMemoryDC,
          hXORDC,
          hANDDC;

  HBITMAP hMemoryBitmap,
          hOldMemoryBitmap,
          hOldXORBitmap,
          hOldANDBitmap;

  HBRUSH  hPinsel,
          hOldBrush;

  HPEN hStift,
       hOldPen;


  BITMAP Bitmap;

  lphXORBitmap[CurrFile] = (HBITMAP FAR*)GlobalLock(hXORBmpMem[CurrFile]);
  lphANDBitmap[CurrFile] = (HBITMAP FAR*)GlobalLock(hANDBmpMem[CurrFile]);
  lphPal[CurrFile] = (HPALETTE FAR*)GlobalLock(hPalMem[CurrFile]);
  lpResDir[CurrFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[CurrFile]);

  hXORDC = CreateCompatibleDC(hDC);
  hANDDC = CreateCompatibleDC(hDC);

  SelectPalette(hXORDC,lphPal[CurrFile][CurrIcon],0);
  RealizePalette(hXORDC);

  hOldXORBitmap = SelectObject(hXORDC,lphXORBitmap[CurrFile][CurrIcon]);
  hOldANDBitmap = SelectObject(hANDDC,lphANDBitmap[CurrFile][CurrIcon]);

  GetObject(lphXORBitmap[CurrFile][CurrIcon], sizeof(BITMAP),(LPSTR) &Bitmap);

  hMemoryDC=CreateCompatibleDC(hDC);
  hMemoryBitmap=CreateCompatibleBitmap(hDC,Bitmap.bmWidth,Bitmap.bmHeight);

  SelectPalette(hMemoryDC,lphPal[CurrFile][CurrIcon],0);
  RealizePalette(hMemoryDC);

  hOldMemoryBitmap = SelectObject(hMemoryDC,hMemoryBitmap);

  hPinsel=CreateSolidBrush(GetNearestColor(hMemoryDC,GetSysColor(COLOR_WINDOW)));
  hOldBrush=SelectObject(hMemoryDC,hPinsel);

  hStift=CreatePen(PS_SOLID,1,GetNearestColor(hMemoryDC,GetSysColor(COLOR_WINDOW)));
  hOldPen=SelectObject(hMemoryDC,hStift);

  Rectangle (hMemoryDC, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight);

  BitBlt(hMemoryDC, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight, hANDDC,0,0,SRCAND);
  BitBlt(hMemoryDC, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight, hXORDC,0,0,SRCINVERT);

  BitBlt(hDC,XPos,YPos,Bitmap.bmWidth,Bitmap.bmHeight,hMemoryDC,0,0,SRCCOPY);

  SelectObject(hMemoryDC,hOldMemoryBitmap);
  SelectObject(hMemoryDC,hOldBrush);
  SelectObject(hMemoryDC,hOldPen);
  DeleteObject(hMemoryBitmap);
  DeleteObject(hPinsel);
  DeleteObject(hStift);
  DeleteDC(hMemoryDC);

  SelectObject(hXORDC,hOldXORBitmap);
  SelectObject(hANDDC,hOldANDBitmap);

  DeleteDC (hXORDC);
  DeleteDC (hANDDC);

  GlobalUnlock(hXORBmpMem[CurrFile]);
  GlobalUnlock(hANDBmpMem[CurrFile]);
  GlobalUnlock(hPalMem[CurrFile]);
  GlobalUnlock(hResDirMem[CurrFile]);
}

void ShowFileName(FileSpec)
LPSTR FileSpec;
{
  char File[128];
  char Path[128];

  SeparateFile(hDlg, (LPSTR)Path, (LPSTR)File, FileSpec);
  SetWindowText(GetDlgItem(hDlg,
                (CurrFile==0) ? ID_FILE1 : ID_FILE2),
                (LPSTR)File);
}

void GetPosition(x, y)
PWORD x, y;
{
  WORD xa, xb, ya, yb;

  lpResDir[CurrFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[CurrFile]);

  lDlgBaseUnits=GetDialogBaseUnits( );
  xa=(int)((89 * LOWORD(lDlgBaseUnits))/4);
  xb=(int)((60 * LOWORD(lDlgBaseUnits))/4);
  *x=xa+(xb-lpResDir[CurrFile][CurrIcon].Width)/2;
  ya=(int)((12 * HIWORD(lDlgBaseUnits))/8);
  yb=(int)((60 * HIWORD(lDlgBaseUnits))/8);
  *y=ya+(yb-lpResDir[CurrFile][CurrIcon].Height)/2;

  GlobalUnlock(hResDirMem[CurrFile]);
}

BOOL FAR PASCAL HelpDlg(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WORD wParam;
LONG lParam;
{
  switch (message)
  {
    case WM_INITDIALOG:
      CenterWnd(hDlg, NULL);
      StrNumber=1;
      OldStrNumber=1;
      LoadString(hInst, StrNumber, (LPSTR)str, 255);
      SetWindowText(GetDlgItem(hDlg, ID_HELPTEXT), (LPSTR)str);
      wsprintf((LPSTR)str, "Seite %i von %i", StrNumber, NUM_HELPTEXT);
      SetWindowText(GetDlgItem(hDlg, ID_PAGETEXT), (LPSTR)str);
      SetScrollRange(GetDlgItem(hDlg, ID_SCROLL), SB_CTL, 1, NUM_HELPTEXT, 0);
      SetScrollPos(GetDlgItem(hDlg, ID_SCROLL), SB_CTL, StrNumber, 1);
      return (TRUE);
    case WM_VSCROLL:
       OldStrNumber=StrNumber;
       switch(wParam)
       {
         case SB_LINEDOWN:
           if(StrNumber<NUM_HELPTEXT) StrNumber++;
           break;
         case SB_LINEUP:
           if(StrNumber>1) StrNumber--;
           break;
         case SB_BOTTOM:
         case SB_PAGEDOWN:
           StrNumber=NUM_HELPTEXT;
           break;
         case SB_TOP:
         case SB_PAGEUP:
           StrNumber=1;
           break;
         case SB_ENDSCROLL:
           break;
         case SB_THUMBPOSITION:
           break;
         case SB_THUMBTRACK:
           StrNumber=LOWORD(lParam);
           break;
       }

       if(OldStrNumber!=StrNumber)
       {
         LoadString(hInst, StrNumber, (LPSTR)str, 255);
         SetWindowText(GetDlgItem(hDlg, ID_HELPTEXT), (LPSTR)str);
         wsprintf((LPSTR)str, "Seite %i von %i", StrNumber, NUM_HELPTEXT);
         SetWindowText(GetDlgItem(hDlg, ID_PAGETEXT), (LPSTR)str);
         SetScrollPos(GetDlgItem(hDlg, ID_SCROLL), SB_CTL, StrNumber, 1);
       }

       return (TRUE);
    case WM_COMMAND:
      if (wParam == IDOK || wParam == IDCANCEL)
      {
        EndDialog(hDlg, TRUE);
        return (TRUE);
      }
      break;
  }
  return (FALSE);
}

void Command(wParam, lParam)
WORD wParam;
DWORD lParam;
{
  switch(wParam)
  {
    case ID_NEW1:
    case ID_NEW2:
      if(wParam==ID_NEW1) CurrFile=0; else CurrFile=1;
      if(QuerySaveFile(hDlg,
                       hXORBmpMem[CurrFile],
                       hANDBmpMem[CurrFile],
                       hPalMem[CurrFile],
                       hResDirMem[CurrFile],
                       Quantity[CurrFile],
                       FileName[CurrFile],
                       &change[CurrFile]))
      {
        change[CurrFile]=FALSE;

        DelAllIcons(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],&Quantity[CurrFile],hDlg);
        SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
          LB_RESETCONTENT, NULL, NULL);

        SendDlgItemMessage(hDlg, (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
          LB_SETCURSEL, -1, NULL);

        lstrcpy((LPSTR)FileName[CurrFile],(LPSTR)"keinname.ico");
        SetWindowText(GetDlgItem(hDlg, (CurrFile==0)?ID_FILE1:ID_FILE2), (LPSTR)FileName[CurrFile]);
        InvalidateRect(hDlg,NULL,TRUE);
        UpdateWindow(hDlg);

        PrevFile=CurrFile;
      }
      break;
    case ID_OPEN1:
    case ID_OPEN2:
      if(wParam==ID_OPEN1) CurrFile=0; else CurrFile=1;
      if(QuerySaveFile(hDlg,hXORBmpMem[CurrFile],hANDBmpMem[CurrFile],hPalMem[CurrFile],hResDirMem[CurrFile],Quantity[CurrFile],FileName[CurrFile],&change[CurrFile]))
      {
        change[CurrFile]=FALSE;

        lstrcpy((LPSTR)OldFileName[CurrFile], (LPSTR)FileName[CurrFile]);
        lstrcpy(DefSpec[CurrFile],"*.ico");
        lpFarProc = MakeProcInstance((FARPROC) OpenDlg, hInst);
        hFile = DialogBox(hInst, "Open", hDlg, lpFarProc);
        FreeProcInstance(lpFarProc);

        if (hFile)
        {
          hOldCursor=SetCursor(hWaitCursor);

          if(WinOS2[CurrFile]=CheckFileType(hFile))
            Result=RetrieveIconFile(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],hFile,hDlg,&Quantity[CurrFile]);
          else
            Result=RetrieveIconFile2(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],hFile,hDlg,&Quantity[CurrFile]);

          SetCursor(hOldCursor);

          if (Result)
          {
            _lclose(hFile);
            CurrIcon=0;

            ShowFileName(FileName[CurrFile]);
            lpResDir[CurrFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[CurrFile]);
            SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                LB_RESETCONTENT, NULL, NULL);

            for(i=0;i<Quantity[CurrFile];i++)
            {
               wsprintf(str,"%ix%i %i Farben",(int)lpResDir[CurrFile][i].Width,(int)lpResDir[CurrFile][i].Height,(int)lpResDir[CurrFile][i].ColorCount);
               SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                 LB_ADDSTRING, NULL, (LONG)(LPSTR)str);
            }

            SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                  LB_SETCURSEL, CurrIcon, NULL);
            SendDlgItemMessage(hDlg, (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
                  LB_SETCURSEL, -1, NULL);

            GlobalUnlock(hResDirMem[CurrFile]);
            GetPosition(&x, &y);
            InvalidateRect(hDlg,NULL,TRUE);
            UpdateWindow(hDlg);
            PrevFile=CurrFile;
            PrevIcon=CurrIcon;
          }
        }
      }
      break;
    case ID_SAVE1:
    case ID_SAVE2:
      if(wParam==ID_SAVE1) CurrFile=0; else CurrFile=1;
      if(Quantity[CurrFile]>0)
      {
        lstrcpy(OldFileName[CurrFile],FileName[CurrFile]);
        lstrcpy(DefSpec[CurrFile],FileName[CurrFile]);
        lpFarProc = MakeProcInstance(SaveAsDlg, hInst);
        Success = DialogBox(hInst, "SaveAs", hDlg, lpFarProc);
        FreeProcInstance(lpFarProc);
        if (Success == IDOK)
        {
          if ((hFile = OpenFile(FileName[CurrFile],(LPOFSTRUCT) &OfStruct, OF_CREATE)) >= 0)
          {
            hOldCursor=SetCursor(hWaitCursor);
            if(WinOS2[CurrFile])
              Result=SaveIconFile(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],hFile, hDlg, Quantity[CurrFile]);
            else
              Result=SaveIconFile2(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],hFile, hDlg, Quantity[CurrFile]);
            SetCursor(hOldCursor);

            if(Result)
            {
              change[CurrFile] = FALSE;
              ShowFileName(FileName[CurrFile]);
            }

            _lclose(hFile);
          }
          else
          {
            wsprintf((LPSTR)str, "Speichern unter %s nicht mglich !", (LPSTR)&FileName[CurrFile]);
            MessageBox(hDlg, str, NULL, MB_OK|MB_ICONHAND);
            lstrcpy((LPSTR)&FileName[CurrFile], (LPSTR)&OldFileName[CurrFile]);
          }
        }
        SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
          LB_SETCURSEL, CurrIcon, NULL);
        SendDlgItemMessage(hDlg, (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
          LB_SETCURSEL, -1, NULL);
        GetPosition(&x, &y);
        InvalidateRect(hDlg,NULL,TRUE);
        UpdateWindow(hDlg);
      }
      PrevFile=CurrFile;
      break;
    case ID_LISTBOX1:
    case ID_LISTBOX2:
      if(wParam==ID_LISTBOX1) CurrFile=0; else CurrFile=1;

      switch(HIWORD(lParam))
      {
        case LBN_SELCHANGE:
          if(PrevFile!=CurrFile)
            SendDlgItemMessage(hDlg, (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
                LB_SETCURSEL, -1, NULL);

          if(Quantity[PrevFile]>0)
          {
            hDC=GetDC(hDlg);
            hBrush=CreateSolidBrush(GetSysColor(COLOR_WINDOW));
            hOldBrush=SelectObject(hDC,hBrush);
            lpResDir[PrevFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[PrevFile]);
            PatBlt(hDC,x,y,lpResDir[PrevFile][PrevIcon].Width,lpResDir[PrevFile][PrevIcon].Height,PATCOPY);
            GlobalUnlock(hResDirMem[PrevFile]);
            SelectObject(hDC,hOldBrush);
            DeleteObject(hBrush);
            ReleaseDC(hDlg,hDC);
          }

          CurrIcon=(int)SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
                LB_GETCURSEL, NULL, NULL);

          GetPosition(&x, &y);
          hDC=GetDC(hDlg);
          ShowIcon(hDC, x, y);
          ReleaseDC(hDlg, hDC);
          PrevFile=CurrFile;
          PrevIcon=CurrIcon;
          break;
      }
      break;
    case ID_COPY:
      if(CurrFile==0) OtherFile=1;
      if(CurrFile==1) OtherFile=0;
      if((Quantity[CurrFile]>0)&&(Quantity[OtherFile]<256))
      {
        Quantity[OtherFile]++;
        change[OtherFile]=TRUE;

        hXORBmpMem[OtherFile] = GlobalReAlloc(hXORBmpMem[OtherFile],sizeof(HBITMAP)*Quantity[OtherFile],GMEM_MOVEABLE);
        hANDBmpMem[OtherFile] = GlobalReAlloc(hANDBmpMem[OtherFile],sizeof(HBITMAP)*Quantity[OtherFile],GMEM_MOVEABLE);
        hPalMem[OtherFile] = GlobalReAlloc(hPalMem[OtherFile],sizeof(HPALETTE)*Quantity[OtherFile],GMEM_MOVEABLE);
        hResDirMem[OtherFile] = GlobalReAlloc(hResDirMem[OtherFile],sizeof(ICONRESOURCE)*Quantity[OtherFile],GMEM_MOVEABLE);

        for(i=0;i<2;i++)
        {
          lphXORBitmap[i] = (HBITMAP FAR*)GlobalLock(hXORBmpMem[i]);
          lphANDBitmap[i] = (HBITMAP FAR*)GlobalLock(hANDBmpMem[i]);
          lphPal[i] = (HPALETTE FAR*)GlobalLock(hPalMem[i]);
          lpResDir[i] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[i]);
        }

        CopyIcon(lphXORBitmap,lphANDBitmap,lphPal,lpResDir,CurrIcon,Quantity[OtherFile],CurrFile,hDlg);

        lpResDir[OtherFile][Quantity[OtherFile]-1]=lpResDir[CurrFile][CurrIcon];

        SendDlgItemMessage(hDlg, (OtherFile==0)?ID_LISTBOX1:ID_LISTBOX2,
          LB_RESETCONTENT, NULL, NULL);

        for(i=0;i<Quantity[OtherFile];i++)
        {
          wsprintf(str,"%ix%i %i Farben",(int)lpResDir[OtherFile][i].Width,(int)lpResDir[OtherFile][i].Height,(int)lpResDir[OtherFile][i].ColorCount);
          SendDlgItemMessage(hDlg, (OtherFile==0)?ID_LISTBOX1:ID_LISTBOX2,
            LB_ADDSTRING, NULL, (LONG)(LPSTR)str);
        }

        for(i=0;i<2;i++)
        {
          GlobalUnlock(hXORBmpMem[i]);
          GlobalUnlock(hANDBmpMem[i]);
          GlobalUnlock(hPalMem[i]);
          GlobalUnlock(hResDirMem[i]);
        }
      }
      break;
    case ID_DELETE:
      if(Quantity[CurrFile]>0)
      {
        hDC=GetDC(hDlg);
        hBrush=CreateSolidBrush(GetSysColor(COLOR_WINDOW));
        hOldBrush=SelectObject(hDC,hBrush);
        lpResDir[PrevFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[PrevFile]);
        PatBlt(hDC,x,y,lpResDir[PrevFile][PrevIcon].Width,lpResDir[PrevFile][PrevIcon].Height,PATCOPY);
        GlobalUnlock(hResDirMem[PrevFile]);
        SelectObject(hDC,hOldBrush);
        DeleteObject(hBrush);
        ReleaseDC(hDlg,hDC);

        DelIcon(&hXORBmpMem[CurrFile],&hANDBmpMem[CurrFile],&hPalMem[CurrFile],&hResDirMem[CurrFile],&Quantity[CurrFile],hDlg,CurrIcon);
        change[CurrFile]=TRUE;
        if(CurrIcon+1>Quantity[CurrFile]) CurrIcon=Quantity[CurrFile]-1;

        SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
              LB_RESETCONTENT, NULL, NULL);

        lpResDir[CurrFile] = (ICONRESOURCE FAR*)GlobalLock(hResDirMem[CurrFile]);

        for(i=0;i<Quantity[CurrFile];i++)
        {
          wsprintf(str,"%ix%i %i Farben",(int)lpResDir[CurrFile][i].Width,(int)lpResDir[CurrFile][i].Height,(int)lpResDir[CurrFile][i].ColorCount);
          SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
             LB_ADDSTRING, NULL, (LONG)(LPSTR)str);
        }

        GlobalUnlock(hResDirMem[CurrFile]);

        SendDlgItemMessage(hDlg, (CurrFile==0)?ID_LISTBOX1:ID_LISTBOX2,
           LB_SETCURSEL, CurrIcon, NULL);
        SendDlgItemMessage(hDlg, (CurrFile==1)?ID_LISTBOX1:ID_LISTBOX2,
           LB_SETCURSEL, -1, NULL);

        if(Quantity[CurrFile]>0)
        {
          GetPosition(&x, &y);
          hDC=GetDC(hDlg);
          ShowIcon(hDC, x, y);
          ReleaseDC(hDlg, hDC);
        }

        PrevFile=CurrFile;
        PrevIcon=CurrIcon;
      }
      break;
  }
}

/* ------------------------------------------------------ */
/*                    Ende von ICOCON.C                   */
