{$A+,B-,D-,E-,F-,G-,I-,K+,N-,O-,P-,Q-,R-,S-,T-,V+,W+,X+,Y+}
{$M 8192,8192}
(* ====================================================== *)
(*                      REEPLAY.PAS                       *)
(*         (C) 1993 Andreas Golgath & DMV-Verlag          *)
(*                  CDPlayer fr Windows 3.1              *)
(*                Compiler: Borland Pascal 7.0            *)
(* ====================================================== *)

PROGRAM ReePlay;

{$R ReePlay.RES}
{$D Reeplay 1.0}

USES
  OWindows, ODialogs, WinProcs, WinTypes,
  BWCC, Strings, CDAudio, TrackWin;

CONST
  AppName       : pChar = 'ReePlayer';
  id_SkipBack           = 101;
  id_SkipForw           = 102;
  id_SearchBack         = 103;
  id_SearchForw         = 104;
  id_Pause              = 105;
  id_Stop               = 106;
  id_Play               = 107;
  id_Volume             = 108;
  id_Info               = 109;
  id_Tracks             = 110;
  id_MMSS               = 111;
  sc_DefineName         = 112;
  id_TheEdit            = 113;
  SearchLen             =  10;

TYPE
  tDlgApp = OBJECT(tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

TYPE
  pReePlay = ^tReePlay;
  tReePlay = OBJECT(tDlgWindow)
    IsPlaying,
    IsPaused:   BOOLEAN;
    Track,
    Min, Sec:   BYTE;
    CDName:     ARRAY [0..59] OF CHAR;
    CONSTRUCTOR Init(aParent: pWindowsObject;
                     aTitle:  pChar);
    FUNCTION    GetClassName: pChar; VIRTUAL;
    PROCEDURE   GetWindowClass(VAR aWndClass: tWndClass);
                VIRTUAL;
    PROCEDURE   SetupWindow; VIRTUAL;
    PROCEDURE   Destroy; VIRTUAL;

    (* Message response methods *)
    PROCEDURE   wmTimer(VAR Msg: tMessage);
                VIRTUAL wm_First + wm_Timer;
    PROCEDURE   wmSysCommand(VAR Msg: tMessage);
                VIRTUAL wm_First + wm_SysCommand;

    (* Button response methods *)
    PROCEDURE   SkipBack(VAR Msg: tMessage);
                VIRTUAL id_First + id_SkipBack;
    PROCEDURE   SkipForw(VAR Msg: tMessage);
                VIRTUAL id_First + id_SkipForw;
    PROCEDURE   SearchBack(VAR Msg: tMessage);
                VIRTUAL id_First + id_SearchBack;
    PROCEDURE   SearchForw(VAR Msg: tMessage);
                VIRTUAL id_First + id_SearchForw;
    PROCEDURE   Pause(VAR Msg: tMessage);
                VIRTUAL id_First + id_Pause;
    PROCEDURE   Stop(VAR Msg: tMessage);
                VIRTUAL id_First + id_Stop;
    PROCEDURE   Play(VAR Msg: tMessage);
                VIRTUAL id_First + id_Play;
    PROCEDURE   Volume(VAR Msg: tMessage);
                VIRTUAL id_First + id_Volume;
    PROCEDURE   Info(VAR Msg: tMessage);
                VIRTUAL id_First + id_Info;

    PROCEDURE   SetTMS(aTrack, aMin, aSec: BYTE);
    PROCEDURE   SetTrack(HowMany: INTEGER);
    PROCEDURE   SetMMSS(aMinute, aSecond: WORD);
  END;

CONSTRUCTOR tReePlay.Init(aParent: pWindowsObject;
                          aTitle:  pChar);
BEGIN
  tDlgWindow.Init(aParent, aTitle);
  IsPlaying := FALSE;
  IsPaused := FALSE;
  StrPCopy(CDName, '[Unknown CD]');
END;

FUNCTION tReePlay.GetClassName: pChar;
BEGIN
  GetClassName := 'BorDlg_CD';
END;

PROCEDURE tReePlay.GetWindowClass(VAR aWndClass: tWndClass);
BEGIN
  tDlgWindow.GetWindowClass(aWndClass);
  aWndClass.lpfnWndProc := @BWCCDefDlgProc;
  aWndClass.hIcon := LoadIcon(hInstance, 'Grapevine');
END;

PROCEDURE tReePlay.SetupWindow;
BEGIN
  tDlgWindow.SetupWindow;
  SetTimer(hWindow, 1, 500, NIL);
  AppendMenu(GetSystemMenu(hWindow, FALSE),
                           mf_Separator, 0, NIL);
  AppendMenu(GetSystemMenu(hWindow, FALSE),
                           mf_String, sc_DefineName,
                           'Identify CD');
END;

PROCEDURE tReePlay.Destroy;
BEGIN
  tDlgWindow.Destroy;
  (*    Soll nach dem Beenden der Applikation die CD      *)
  (*    weitergespielt werden, kommentieren Sie die       *)
  (*    folgende Zeile aus:                               *)
  cdStop;
  KillTimer(hWindow, 1);
END;

PROCEDURE tReePlay.SetTMS(aTrack, aMin, aSec: BYTE);
BEGIN
  Track := aTrack;
  Min   := aMin;
  Sec   := aSec;
END;

PROCEDURE tReePlay.wmTimer(VAR Msg: tMessage);
VAR
  Frame: BYTE;
BEGIN
  IF IsPlaying THEN GetTMSF(Track, Min, Sec, Frame)
               ELSE SetTMS(0, 0, 0);
  SetTrack(Track);
  SetMMSS(Min, Sec);
END;

PROCEDURE tReePlay.wmSysCommand(VAR Msg: tMessage);
VAR
  Dialog: pDialog;
  p     : pWindowsObject;
BEGIN
  IF (Msg.wParam = sc_DefineName) THEN BEGIN
    Dialog := New(pDialog,
                  Init(@Self, pChar('ArtistTitle')));
    Dialog^.TransferBuffer := @CDName;
    p := New(pEdit, InitResource(Dialog, id_TheEdit, 60));
    Application^.ExecDialog(Dialog);
  END;
  DefWndProc(Msg);
END;

PROCEDURE tReePlay.SkipBack(VAR Msg: tMessage);
BEGIN
  IF (Track > 1) THEN cdPlay(Track - 1, HowManyTracks)
                 ELSE cdPlay(1,         HowManyTracks);
END;

PROCEDURE tReePlay.SkipForw(VAR Msg: tMessage);
BEGIN
  IF (Track < HowManyTracks) THEN
    cdPlay(Track + 1, HowManyTracks)
  ELSE
    cdPlay(HowManyTracks, HowManyTracks + 1);
END;

PROCEDURE tReePlay.SearchBack(VAR Msg: tMessage);
BEGIN
  cdStop;
  IF (Sec < SearchLen) THEN BEGIN
    Sec := Sec + 60 - SearchLen;
    Dec(Min);
  END;
  cdGoto(Track, Min, Sec - SearchLen);
END;

PROCEDURE tReePlay.SearchForw(VAR Msg: tMessage);
BEGIN
  cdStop;
  IF (Sec > 60-SearchLen) THEN BEGIN
    Inc(Min);
    Sec := Sec - 60 + SearchLen;
  END;
  cdGoto(Track, Min, Sec + SearchLen);
END;

PROCEDURE tReePlay.Pause(VAR Msg: tMessage);
VAR
  ReturnCode: LONGINT;
BEGIN
  IF IsPaused THEN BEGIN
    cdGoto(Track, Min, Sec);
    IsPaused := FALSE;
  END ELSE BEGIN
    cdStop;
    IsPaused := TRUE;
  END;
END;

PROCEDURE tReePlay.Stop(VAR Msg: tMessage);
VAR
  ReturnCode: LONGINT;
BEGIN
  IF IsPlaying THEN BEGIN
    ReturnCode := cdStop;
    IF (ReturnCode <> 0) THEN ShowError(ReturnCode);
    ReturnCode := cdClose;
    IsPlaying  := FALSE;
  END;
END;

PROCEDURE tReePlay.SetMMSS(aMinute, aSecond: WORD);
VAR
  Buffer: ARRAY[0..6] OF CHAR;
  Args  : ARRAY[0..1] OF WORD;
BEGIN
  Args[0] := Min;
  Args[1] := Sec;
  wvSprintF(Buffer, '%d:%02d', Args);
  SetWindowText(GetDlgItem(hWindow, id_MMSS), Buffer);
END;

PROCEDURE tReePlay.SetTrack(HowMany: INTEGER);
VAR
  Buffer: ARRAY[0..3] OF CHAR;
BEGIN
  wvSprintF(Buffer, '%d', HowMany);
  SetWindowText(GetDlgItem(hWindow, id_Tracks), Buffer);
END;

PROCEDURE tReePlay.Play(VAR Msg: tMessage);
VAR
  ReturnCode: LONGINT;
BEGIN
  IF NOT IsPlaying THEN BEGIN
    ReturnCode := cdOpen;
    ReturnCode := cdPlay(1, HowManyTracks);
    SetTrack(HowManyTracks);
    IsPlaying := TRUE;
  END;
END;

PROCEDURE tReePlay.Volume(VAR Msg: tMessage);
VAR
  What2Exec: ARRAY[0..79] OF CHAR;
  RetCode  : WORD;
BEGIN
  LoadString(hInstance, 1, What2Exec, 79);
  RetCode := WinExec(What2Exec, sw_Normal);
  IF (RetCode < 32) THEN
    MessageBox(0, 'Volume (SBPro Mixer) couldn''t be ' +
                  'launched.'#13#10'Please check path' +
                  ' name in stringtable resource.',
                  'Problem', mb_OK);
END;

PROCEDURE tReePlay.Info(VAR Msg: tMessage);
BEGIN
  IF (TrackWindow = NIL) THEN BEGIN
    TrackWindow := New(pTrackWindow, Init(CDName));
    IF (Application^.MakeWindow(TrackWindow) <> NIL) THEN
      TrackWindow^.Show(sw_Show);
  END;
END;

PROCEDURE tDlgApp.InitMainWindow;
BEGIN
  MainWindow := New(pReePlay,
                    Init(NIL, MakeIntResource('CDPlayer')));
END;

VAR
  MyDlgApp: tDlgApp;

BEGIN
  MyDlgApp.Init(AppName);
  MyDlgApp.Run;
  MyDlgApp.Done;
END.

(* ====================================================== *)
(*                   Ende von REEPLAY.PAS                 *)
