" - - - - -  PSG-Grammatik - Parser  - - - - - "

syntax(d,d1,s-atz) -> satz(d,d1,s-atz) /;
syntax(d,d1,KEIN-SATZ) ->;

satz(d,d2,satz(<n-p,v-p>)) ->
   np(d,d1,s-ubkat,n-p)
   vp(d1,d2,s-ubkat,v-p);

np(d,d1,a.b.c,np(<en,x,a.b.c>)) ->
   eigenname(d,d1,<en,x,a.b.c>);
np(d,d2,a.b.c,np(<art,x,a.b.c>,nomen(y,a.b.c))) ->
   artikel(d,d1,<art,x,a.b.c>)
   nomen(d1,d2,nomen(y,a.b.c));
np(d,d3,a.b.c,np(<art,x,a.b.c>,<adj,y,a.b.c>,nomen(z,a.b.c))) ->
   artikel(d,d1,<art,x,a.b.c>)
   adjektiv(d1,d2,<adj,y,a.b.c>)
   nomen(d2,d3,nomen(z,a.b.c));

pp(d,d2,a.b.c,pp(<<praep,x,a.b.c>,n-p>)) ->
   praeposition(d,d1,<praep,x,a.b.c>)
   np(d1,d2,a.b.c,n-p);

vp(d,d1,a.b.c,vp(verb(x,a.b.c))) ->
   verb(d,d1,verb(x,a.b.c));
vp(d,d2,a1.b1.c1,vp(<verb(x,a1.b1.c1,a2.b2.c2),n-p>)) ->
   verb(d,d1,verb(x,a1.b1.c1,a2.b2.c2))
   np(d1,d2,a2.b2.c2,n-p);
vp(d,d2,a1.b1.c1,vp(<verb(x,a1.b1.c1,a2.b2.c2),p-p>)) ->
   verb(d,d1,verb(x,a1.b1.c1,a2.b2.c2))
   pp(d1,d2,a2.b2.c2,p-p);
vp(d,d3,a1.b1.c1,vp(<verb(x,a1.b1.c1,a2.b2.c2,a3.b3.c3),p-p1,p-p2>)) ->
   verb(d,d1,verb(x,a1.b1.c1,a2.b2.c2,a3.b3.c3))
   pp(d1,d2,a2.b2.c2,p-p1)
   pp(d2,d3,a3.b3.c3,p-p2);

" - - - - -  Hauptprogramm  - - - - - "

lesen(nil) -> next-char'(".") / in-char'(".");
lesen(c.b) -> in-word(a,c) lesen(b);

psg ->
   repeat
   line
   outm("Satz:        ")
   lesen(d)
   syntax(d,nil,y)
   outm("Syntax:      ")
   outl(y)
   fail;

repeat ->;
repeat -> repeat;

" - - - - -  Datenbank  - - - - - "

eigenname(Hans.d,d,<en,Hans,sg.mas.c>) ->;
eigenname(Maria.d,d,<en,Maria,sg.fem.c>) ->;

artikel(das.d,d,<art,das,sg.b.c>) ->;
artikel(einem.d,d,<art,einem,sg.b.c>) ->;

adjektiv(anregenden.d,d,<adj,anregenden,sg.b.c>) ->;
adjektiv(anregende.d,d,<adj,anregende,sg.b.c>) ->;

nomen(Kind.d,d,nomen(Kind,sg.ntr.c)) ->;
nomen(Wochenende.d,d,nomen(Wochenende,sg.ntr.c)) ->;

praeposition(von.d,d,<praep,von,a.b.dat>) ->;
praeposition(mit.d,d,<praep,mit,a.b.dat>) ->;

verb(traeumt.d,d,verb(traeumt,sg.b1.nom)) ->;
verb(traeumt.d,d,verb(traeumt,sg.b1.nom,a2.b2.dat)) ->;
verb(traeumt.d,d,verb(traeumt,sg.b1.nom,a2.b2.dat,a3.b3.dat)) ->;
verb(liebt.d,d,verb(liebt,sg.b1.nom,a2.b2.akk)) ->;

;End world: Normal