(*========================================================*)
(*                         ID.PAS                         *)
(*          Unit fr TESTMODE.PAS und READBIOS.PAS        *)
(*             (C) 1993 Jrg Braun & DMV-Verlag           *)
(*========================================================*)
{$I xgraph.h}

UNIT Id;

INTERFACE

  USES
     DOS{NameStr};

  PROCEDURE Identify(VAR FName: NameStr);

IMPLEMENTATION

  PROCEDURE Identify(VAR FName: NameStr);
  TYPE
    CharArray = ARRAY[0..254] OF CHAR;
  VAR
    BIOSBuf  : CharArray ABSOLUTE $C000:$0005;(* ROM-BIOS *)
    s        : CharArray;
    i        : BYTE;
  BEGIN
    Move(BIOSBuf, s, 255);
    FOR i := 0 TO 254 DO s[i] := UpCase(s[i]);
    IF Pos('TSENG',     s) > 0 THEN FName := 'TSENG'    ELSE
    IF Pos('PEGA',      s) > 0 THEN FName := 'PEGA'     ELSE
    IF Pos('PARADISE',  s) > 0 THEN FName := 'PARADISE' ELSE
    IF Pos('WESTERN',   s) > 0 THEN FName := 'WESTERN'  ELSE
    IF Pos('SIGMA',     s) > 0 THEN FName := 'SIGMA'    ELSE
    IF Pos('761295520', s) > 0 THEN FName := 'ATI'      ELSE
    IF (Pos('OAK',     s) > 0) OR
       (Pos('OTI',     s) > 0) THEN FName := 'OAK-OTI'  ELSE
    IF Pos('TRIDENT',   s) > 0 THEN FName := 'TRIDENT'  ELSE
    IF Pos('CHIPS',     s) > 0 THEN FName := 'CHIPS'    ELSE
    IF Pos('ZYMOS',     s) > 0 THEN FName := 'ZYMOS'    ELSE
    IF Pos('VIDEO SEV', s) > 0 THEN FName := 'VIDEO7'   ELSE
    IF Pos('ZYXEL',     s) > 0 THEN FName := 'ZYXEL'    ELSE
    IF Pos('AT&T',      s) > 0 THEN FName := 'AT_T'     ELSE
    IF Pos('OLIVETTI',  s) > 0 THEN FName := 'OLIVETTI' ELSE
    IF Pos('TANDY',     s) > 0 THEN FName := 'TANDY'    ELSE
      FName := 'GRAFBIOS';   (* irgend etwas unbekanntes! *)

    IF FName = 'TSENG' THEN BEGIN   (* Tseng-Chip-Prfung *)
      IF Port[$3CD] AND $C0 = 0 THEN FName := 'ET4000'
                                ELSE FName := 'ET3000';
    END;
  END;

END.

(*========================================================*)
(*                      Ende von ID.INC                   *)
